
local drunk = false

RegisterNetEvent("ples:setDrunk", function(togg)
	drunk = togg
end)

local townPos <const>, townRadius <const> = vector3(-117.53279876709, -1353.1544189453, 29.33846282959), 2500.0
local favelaPos <const>, favelaRadius <const> = vector3(1474.563, -81.244, 153.530), 350.0
local shotTime = 0

local recoils = {
	[GetHashKey("WEAPON_APPISTOL")] = {shake = 0.05, recoil = 0.1},
	[GetHashKey("WEAPON_COMBATPISTOL")] = {shake = 0.03, recoil = 0.2},
	[GetHashKey("WEAPON_DOUBLEACTION")] = {shake = 0.5, recoil = 1.5},
	[GetHashKey("WEAPON_HEAVYPISTOL")] = {shake = 0.03, recoil = 0.5},
	[GetHashKey("WEAPON_PISTOL_MK2")] = {shake = 0.03, recoil = 0.3},
	[GetHashKey("WEAPON_PISTOL")] = {shake = 0.030, recoil = 0.5},
	[GetHashKey("WEAPON_PISTOL50")] = {shake = 0.22, recoil = 0.35},
	[GetHashKey("WEAPON_SNSPISTOL")] = {shake = 0.15, recoil = 0.35},
	[GetHashKey("WEAPON_STUNGUN")] = {shake = 0.01, recoil = 0.1},
	[GetHashKey("WEAPON_VINTAGEPISTOL")] = {shake = 0.1, recoil = 0.7},
	[GetHashKey("WEAPON_GADGETPISTOL")] = {shake = 0.3, recoil = 0.6},
	[GetHashKey("WEAPON_NAVYREVOLVER")] = {shake = 2, recoil = 0.8},
	[GetHashKey("WEAPON_CERAMICPISTOL")] = {shake = 0.03, recoil = 0.2},
	[GetHashKey("WEAPON_ASSAULTSMG")] = {shake = 0.050, recoil = 0.1},
	[GetHashKey("WEAPON_COMBATMG")] = {shake = 0.08, recoil = 0.1},
	[GetHashKey("WEAPON_COMBATPDW")] = {shake = 0.045, recoil = 0.2},  -- micsorat damage curr damage = 25
	[GetHashKey("WEAPON_GUSENBERG")] = {shake = 0.1, recoil = 0.3}, -- micsorat damage curr damage = 34
	[GetHashKey("WEAPON_MACHINEPISTOL")] = {shake = 0.05, recoil = 0.8}, -- micsorat damage curr damage = 28
	[GetHashKey("WEAPON_MG")] = {shake = 0.1, recoil = 0.2},
	[GetHashKey("WEAPON_MINISMG")] = {shake = 0.035, recoil = 0.1}, -- ???
	[GetHashKey("WEAPON_MICROSMG")] = {shake = 0.035, recoil = 0.2},
	[GetHashKey("WEAPON_SMG")] = {shake = 0.035, recoil = 0.1},
	[GetHashKey("WEAPON_SMG_MK2")] = {shake = 0.055, recoil = 0.1},
	[GetHashKey("WEAPON_ASSAULTRIFLE")] = {shake = 0.07, recoil = 0.2},
	[GetHashKey("WEAPON_ASSAULTRIFLE_MK2")] = {shake = 0.01, recoil = 0.2},
	[GetHashKey("WEAPON_BULLPUPRIFLE_MK2")] = {shake = 0.065, recoil = 0.25},
	[GetHashKey("WEAPON_CARBINERIFLE")] = {shake = 0.05, recoil = 0.05},
	[GetHashKey("WEAPON_CARBINERIFLE_MK2")] = {shake = 0.065, recoil = 0.1},
	[GetHashKey("WEAPON_COMPACTRIFLE")] = {shake = 0.1, recoil = 0.4},
	[GetHashKey("WEAPON_BULLPUPRIFLE")] = {shake = 0.05, recoil = 0.2},
	[GetHashKey("WEAPON_SPECIALCARBINE_MK2")] = {shake = 0.075, recoil = 0.25},
	[GetHashKey("WEAPON_SPECIALCARBINE")] = {shake = 0.06, recoil = 0.2},
	[GetHashKey("WEAPON_MILITARYRIFLE")] = {shake = 0.05, recoil = 0.05},
	[GetHashKey("WEAPON_ADVANCEDRIFLE")] = {shake = 0.06, recoil = 0.1},
	[GetHashKey("WEAPON_DBSHOTGUN")] = {shake = 0.05, recoil = 0.7},
	[GetHashKey("WEAPON_PUMPSHOTGUN")] = {shake = 0.07, recoil = 0.4},
	[GetHashKey("WEAPON_PUMPSHOTGUN_MK2")] = {shake = 0.085, recoil = 0.4},
	[GetHashKey("WEAPON_SAWNOFFSHOTGUN")] = {shake = 0.06, recoil = 0.7},
	[GetHashKey("WEAPON_MUSKET")] = {shake = 0.04, recoil = 0.7},
	-- [GetHashKey("WEAPON_SNOWBALL")] = {shake = 0.0, recoil = 0.0, dmgModifier = 0.0},
	[GetHashKey("WEAPON_GLOCK17")] = {shake = 0.01, recoil = 0.1},
    [GetHashKey("WEAPON_GLOCK19")] = {shake = 0.01, recoil = 0.1},
    [GetHashKey("WEAPON_AR15")] = {shake = 0.01, recoil = 0.1}, 
    [GetHashKey("WEAPON_BERYL")] = {shake = 0.01, recoil = 0.2},
    [GetHashKey("WEAPON_GALIL52")] = {shake = 0.01, recoil = 0.2},
    [GetHashKey("WEAPON_P90")] = {shake = 0.01, recoil = 0.2},
    [GetHashKey("WEAPON_M4COLT")] = {shake = 0.01, recoil = 0.1},
    [GetHashKey("WEAPON_HERA15")] = {shake = 0.01, recoil = 0.2}, 
    [GetHashKey("WEAPON_FIVESEVEN")] = {shake = 0.01, recoil = 0.2},
    [GetHashKey("WEAPON_M9BERETTA")] = {shake = 0.01, recoil = 0.2},
    [GetHashKey("WEAPON_M9A3")] = {shake = 0.01, recoil = 0.2},
}

-- RegisterCommand("testrecoil", function(player, args)

-- 	local weaponName = args[1]
-- 	local weaponHash = GetHashKey(weaponName)

-- 	if not weaponName then
-- 		TriggerEvent("chatMessage", "/testrecoil <weaponName> <shake 0.0-2.0> <recoil 0.0-2.0>")
-- 		return
-- 	end
	
-- 	local shake = tonumber(args[2])
-- 	local recoil = tonumber(args[3])
	
-- 	if not shake or not recoil then
-- 		local currentRecoil = recoils[weaponHash]
-- 		if not currentRecoil then
-- 			TriggerEvent("chatMessage", "Nu exista recoil pentru "..weaponName.." ("..weaponHash..")")
-- 			return
-- 		end

-- 		TriggerEvent("chatMessage", "Recoil pentru "..weaponName.." ("..weaponHash.."): shake "..currentRecoil.shake..", recoil "..currentRecoil.recoil)
-- 		return
-- 	end

-- 	recoils[weaponHash] = {shake = shake, recoil = recoil}
-- 	TriggerEvent("chatMessage", "Recoil changed for "..weaponName.." ("..weaponHash..") CLIENT-ONLY")
-- end)

-- Citizen.CreateThread(function()
-- 	while true do
-- 		Citizen.Wait(500)
-- 		-- drive by only in first-person
-- 		SetPlayerCanDoDriveBy(PlayerId(), GetFollowPedCamViewMode() == 4)
-- 	end
-- end)

Citizen.CreateThread(function()
	while true do
		Citizen.Wait(1)
		local ped = PlayerPedId()
		local weapon = GetSelectedPedWeapon(ped)


		--print(weapon) -- To get the weapon hash by pressing F8 in game
		
		-- Disable melee while aiming (may be not working)
		
		if IsPedArmed(ped, 6) then
        	DisableControlAction(1, 140, true)
            DisableControlAction(1, 141, true)
            DisableControlAction(1, 142, true)
        end
		
		-- Disable ammo HUD
		
		DisplayAmmoThisFrame()

		-- Disable Criticals
		
		-- aka disable headshot
		-- SetPedSuffersCriticalHits(ped)
		
		-- Shakycam
		
		if not drunk and IsPedShooting(ped) then

			if weapon == GetHashKey("WEAPON_FIREEXTINGUISHER") then
				SetPedInfiniteAmmo(ped, true, GetHashKey("WEAPON_FIREEXTINGUISHER"))
			elseif weapon ~= GetHashKey("WEAPON_SNOWBALL") and weapon ~= GetHashKey("WEAPON_JERRYCAN") and weapon ~= GetHashKey("WEAPON_STUNGUN") then
				if shotTime < GetGameTimer() then
					shotTime = GetGameTimer() + 500

					TriggerServerEvent("fury:shotFired", true)

					if not IsPedCurrentWeaponSilenced(ped) or math.random(1, 1000) < 60 then
						math.randomseed(GetGameTimer())
						local chance = math.random(1, 100)
						if chance < 40 then
							local interiorId = GetInteriorFromEntity(ped)
							local playerCoords = GetEntityCoords(ped)
							local diff = #(playerCoords - vector3(-264.33, -703.86, 69.06))
							if diff > 20.0 and interiorId == 0 then
								local pos = GetEntityCoords(ped)
								if #(pos - townPos) < townRadius then
									if #(pos - favelaPos) > favelaRadius then
										TriggerServerEvent("fury:shotFired")
										shotTime = GetGameTimer() + 5000
									end
								end
							end
						end
					end
				end

				if HasBulletImpactedInArea(vector3(-621.323, -230.387, 38.042), 10.0) then
					TriggerServerEvent("theo:vangelicoServer:startHeist")
					Citizen.Wait(100)
				end
				
				if recoils[weapon] then
					if not IsPedDoingDriveby(ped) then
						if recoils[weapon].shake then
							ShakeGameplayCam('SMALL_EXPLOSION_SHAKE', recoils[weapon].shake)
						end

						if recoils[weapon].recoil then
							local tv = 0
							repeat
								Citizen.Wait(1)
								local p = GetGameplayCamRelativePitch()
								if GetFollowPedCamViewMode() ~= 4 then
									SetGameplayCamRelativePitch(p + 0.6, 0.2)
								end
								tv = tv + 0.1
							until tv >= recoils[weapon].recoil
						end
					else

						local veh = GetVehiclePedIsIn(ped, false)
						local model = GetEntityModel(veh)

						if IsThisModelACar(model) or IsThisModelABike(model) then
							TriggerServerEvent("ple$:X", "Drive By Detected")
						end
						return
					end
				end

				
			end
		end
	end
end)


local waitingForClean = false
AddStateBagChangeHandler("shotFired", ("player:%d"):format(GetPlayerServerId(PlayerId())), function(bagName, key, shotFired)

	if not shotFired then
		return
	end

	if waitingForClean then
		return
	end

	waitingForClean = true

	while true do

		local ped = PlayerPedId()

		if IsPedSwimming(ped) or IsPedSwimmingUnderWater(ped) then
			TriggerEvent("furyNotify", "Te-ai spalat de praful de pusca si nu mai esti detectabil de catre politie.", 10000)
			TriggerServerEvent("ples:washShotFired")
			waitingForClean = false
			break
		end

		Citizen.Wait(5000)
	end


end)